// md5sumDlg.cpp : implementation file
//
//#include <sys/types.h>
#include <stdio.h>
//#include <unistd.h>
#include <sys/stat.h>

#include "stdafx.h"
#include "md5sum.h"
#include "md5sumDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD WINAPI Cmd5sumDlgThreadProc(LPVOID lpParameter);

typedef struct 
{
	char *fullpath;
	char *displaypath;
} FileRecord;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Cmd5sumDlg dialog

Cmd5sumDlg::Cmd5sumDlg(CWnd* pParent /*=NULL*/)
: CDialog(Cmd5sumDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(Cmd5sumDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cmd5sumDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Cmd5sumDlg)
	DDX_Control(pDX, IDC_RESULTSEDIT, m_resultsedit);
	DDX_Control(pDX, IDOK, m_quitbutton);
	DDX_Control(pDX, IDC_PROGRESSBAR, m_progressbar);
	DDX_Control(pDX, IDC_FILENAMEEDIT, m_filenameedit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(Cmd5sumDlg, CDialog)
//{{AFX_MSG_MAP(Cmd5sumDlg)
ON_WM_SYSCOMMAND()
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_WM_SIZE()
ON_WM_GETMINMAXINFO()
ON_WM_DROPFILES()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Cmd5sumDlg message handlers

BOOL Cmd5sumDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.
	
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	DWORD threadid;
	CreateThread(NULL,0,Cmd5sumDlgThreadProc,this,0,&threadid);
	
	// TODO: Add extra initialization here
	// use courier
	CFont *courierfont=new CFont();
	courierfont->CreatePointFont(10,"Courier",NULL);
	
	m_resultsedit.SetFont(courierfont,true);
	m_resultsedit.SetBackgroundColor(false,GetSysColor(COLOR_3DFACE));
	
	// set up the lyout manager
	m_layoutmanager.setOwner(this);
	CRect crect;
	crect.top=0; crect.bottom=0; crect.left=0; crect.right=0;
	GetClientRect(&crect);
	m_layoutmanager.setOrigSize(&crect);
	m_layoutmanager.add(&m_resultsedit,1.0,1.0,LayoutManager::kBottomLeft);
	m_layoutmanager.add(&m_progressbar,1.0,0.0,LayoutManager::kTopLeft);
	m_layoutmanager.add(&m_filenameedit,1.0,0.0,LayoutManager::kTopRight);
	m_layoutmanager.add(&m_quitbutton,0.0,0.0,LayoutManager::kBottomRight);
	
	m_filenameedit.SetSel(0,-1,false);
	m_filenameedit.ReplaceSel("");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void Cmd5sumDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cmd5sumDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cmd5sumDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void Cmd5sumDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	m_layoutmanager.OnSize(nType,cx,cy);
}

void Cmd5sumDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: Add your message handler code here and/or call default
	
	m_layoutmanager.OnGetMinMaxInfo(lpMMI);
	//	CDialog::OnGetMinMaxInfo(lpMMI);
}

void Cmd5sumDlg::OnDropFiles(HDROP hDropInfo) 
{
	int filecount=DragQueryFile(hDropInfo,-1,NULL,0);
	
	for (int fileidx=0;fileidx<filecount;fileidx++)
	{
		int bufsize=DragQueryFile(hDropInfo,fileidx,NULL,0);
		char *fullpath=(char*) malloc(bufsize+2);
		
		DragQueryFile(hDropInfo,fileidx,fullpath,bufsize+1);
		
		enqueuePath(fullpath);
		free(fullpath);		
	}
	
	CDialog::OnDropFiles(hDropInfo);
}

void Cmd5sumDlg::enqueuePath(char *fullpath)
{
	FileRecord *fr=(FileRecord*) malloc(sizeof(FileRecord));
	
	fr->fullpath=strdup(fullpath);

	char *displaypath=strrchr(fr->fullpath,'\\');
	if (displaypath==NULL || displaypath[0]==0)
		displaypath=fr->fullpath;
	else
		displaypath=&displaypath[1]; // skip the separator.
	
	fr->displaypath=strdup(displaypath);
	
	m_filequeue.push(fr);
	
}

DWORD WINAPI Cmd5sumDlgThreadProc(LPVOID lpParameter)
{
	Cmd5sumDlg *dlg=(Cmd5sumDlg*) lpParameter;
	
	while(1)
	{
		FileRecord *fr=(FileRecord*) dlg->m_filequeue.pop();
		
		dlg->processFile(fr->fullpath,fr->displaypath);
		free(fr->fullpath);
		free(fr->displaypath);
		free(fr);
	}
}

#define BUFFERSIZE 65536

void Cmd5sumDlg::processFile(char *filenamebuf, char *displayfilename)
{
	m_filenameedit.SetScrollPos(SB_HORZ,0,true);
	m_filenameedit.SetSel(0,-1,false);
	m_filenameedit.ReplaceSel(filenamebuf);
	
	//	m_resultsedit.SetSel(0,-1,false);
	//	m_resultsedit.ReplaceSel("Calculating...");
	
	md5_state_t state;
	md5_byte_t digest[16];
	
	md5_init(&state);
	
	FILE *f=fopen(filenamebuf,"rb");
	if (f==NULL)
	{
		char errorbuf[1024];
		if (errno==13)
			sprintf(errorbuf,"Sorry, I can't read directories.");
		else
			sprintf(errorbuf,"Couldn't open file, errno=%i",errno);
		MessageBox(errorbuf);
		return;
	}
	
	
	char databuf[BUFFERSIZE];
	unsigned int databufsize;
	struct _stat thestat;
	_fstat(fileno(f),&thestat);
	
	int blocksread=0;
	int blocks=thestat.st_size/BUFFERSIZE;
	
	m_progressbar.SetRange(0,blocks/64);
	m_progressbar.SetPos(0);
	
	while ((databufsize=fread(databuf,1,BUFFERSIZE,f))>0)
	{
		blocksread++;
		md5_append(&state,(const md5_byte_t *) databuf,databufsize);
		if (blocksread%64==0)
			m_progressbar.SetPos(blocksread/64);
	}
	
	fclose(f);
	md5_finish(&state, digest);
	
	m_resultsedit.SetSel(-1,-1);
	
	char md5buf[1024];
	int di;
	for (di = 0; di < 16; ++di)
		sprintf(&md5buf[di*2],"%02x", digest[di]);
	
	m_resultsedit.SetSel(-1,-1);
	m_resultsedit.ReplaceSel(md5buf);
	
	sprintf(md5buf,"   %s",displayfilename);
	//	m_resultsedit.SetSel(-1,-1,false);
	m_resultsedit.ReplaceSel(md5buf);
	
	char newline[3];
	newline[0]=0x0d;
	newline[1]=0x0a;
	newline[2]=0;
	
	m_resultsedit.SetSel(-1,-1);
	m_resultsedit.ReplaceSel(newline);
	
	m_filenameedit.SetSel(0,-1,false);
	m_filenameedit.ReplaceSel("");
	
}
